%Optimierung im Zeitbereich
%optimierung_alle_kriterien_n2.m
clear, clc, format long

delta_t = 0.00001; tmax = 100; n = round(tmax / delta_t);
x = zeros (n+1,1); t = zeros (n+1,1); t = 0:delta_t:tmax; da = 0.0001; 

%Betragsregelflche IAE
A_min = inf;
for D = 0.6623:da:0.6625
    
    Ds = sqrt(1.0 - D*D); Ac = acos(D);
    x = 1.0 - exp(-D*t) .* sin(Ds*t + Ac) / Ds;
    %x = step(tf (1.0, [1 2.0*D 1]), t);
    A = delta_t * sum(abs(1.0 - x));
    if A_min > A
       A_min = A; ue = max(x) - 1.0; D_opt = D;
    end
    
end
D_opt_IAE = D_opt, A_min, ue

%Zeitgewichtete Betragsregelflche ITAE
A_min = inf;
for D = 0.7523:da:0.7525   
    Ds = sqrt(1.0 - D*D); Ac = acos(D);
    x = 1.0 - exp(-D*t) .* sin(Ds*t + Ac) / Ds;
    %x = step(tf (1.0, [1 2.0*D 1]), t);
    A = delta_t * dot(t, abs(1.0 - x));
    if A_min > A
       A_min = A; ue = max(x) - 1.0; D_opt = D;
    end
    
end
D_opt_ITAE = D_opt, A_min, ue

%Zeitquadratgewichtete Betragsregelflche ISTAE
A_min = inf;
for D = 0.8137:da:0.8139  
    Ds = sqrt(1.0 - D*D); Ac = acos(D);
    x = 1.0 - exp(-D*t) .* sin(Ds*t + Ac) / Ds;
    %x = step(tf (1.0, [1 2.0*D 1]), t);
    A = delta_t * dot(t .* t, abs(1.0 - x));
    if A_min > A
       A_min = A; ue = max(x) - 1.0; D_opt = D;
    end
    
end
D_opt_ISTAE = D_opt, A_min, ue

%Quadratische Regelflche ISE
A_min = inf;
for D = 0.4999:da:0.5001  
    Ds = sqrt(1.0 - D*D); Ac = acos(D);
    x = 1.0 - exp(-D*t) .* sin(Ds*t + Ac) / Ds;
    %x = step(tf (1.0, [1 2.0*D 1]), t);
    A = delta_t * dot((1.0 - x),(1.0 - x));
    if A_min > A
       A_min = A; ue = max(x) - 1.0; D_opt = D;
    end
    
end
D_opt_ISE = D_opt, A_min, ue

%Zeitgewichtete Quadratische Regelflche ITSE
A_min = inf;
for D = 0.5945:da:0.5947  
    Ds = sqrt(1.0 - D*D); Ac = acos(D);
    x = 1.0 - exp(-D*t) .* sin(Ds*t + Ac) / Ds;
    %x = step(tf (1.0, [1 2.0*D 1]), t);
    A = delta_t * dot(t, (1.0 - x).*(1.0 - x));
    if A_min > A
       A_min = A; ue = max(x) - 1.0; D_opt = D;
    end
    
end
D_opt_ITSE = D_opt, A_min, ue


%Zeitquadratgewichtete Quadratische Regelflche ISTSE
A_min = inf;
for D = 0.6672:da:0.6674  
    Ds = sqrt(1.0 - D*D); Ac = acos(D);
    x = 1.0 - exp(-D*t) .* sin(Ds*t + Ac) / Ds;
    %x = step(tf (1.0, [1 2.0*D 1]), t);
    A = delta_t * dot(t .* t, (1.0 - x).*(1.0 - x));
    if A_min > A
       A_min = A; ue = max(x) - 1.0; D_opt = D;
    end
    
end
D_opt_ISTSE = D_opt, A_min, ue

%{
%Betragsregelflche IAE
D_opt_IAE =   0.662400000000000
A_min =   1.605148556065305
ue =   0.062175047365894

%Zeitgewichtete Betragsregelflche ITAE
D_opt_ITAE =   0.752400000000000
A_min =   1.951859483565610
ue =   0.027641182613718

%Zeitquadratgewichtete Betragsregelflche ISTAE
D_opt_ISTAE =   0.813800000000000
A_min =   4.331462533959664
ue =   0.012286006442300

%Quadratische Regelflche ISE
D_opt_ISE =   0.500000000000000
A_min =   1.000004999997881
ue =   0.163033534821449

%Zeitgewichtete Quadratische Regelflche ITSE
D_opt_ITSE =   0.594600000000000
A_min =   0.707106781224409
ue =   0.097948909164117

%Zeitquadratgewichtete Quadratische Regelflche ISTSE
D_opt_ISTSE =   0.667300000000000
A_min =   0.868630067579477
ue =   0.059920514578427
%}


