%Optimierung im Zeitbereich, System II. Ordnung
%optimierung_alle_kriterien_n2_bild.m
clear, clc, clf, format long

delta_t = 0.01; tmax = 100; n = round(tmax / delta_t);
x = zeros (n+1,1); t = 0:delta_t:tmax; da = 0.01; 
DD = 0.0:da:1.6; nD = length(DD)+1;

%Betragsregelflche IAE
i = 1;
for D = DD
    x = step(tf (1.0, [1 2.0*D 1]), t);
    A(i) = delta_t * trapz(abs(1.0 - x));
    i = i + 1;
end
plot(DD, A), grid on, hold on, axis ([0 1.6 0 6])
title ('Werte der Integralkriterien  A = f(D)  fr ein System II. Ordnung')
xlabel ('Dmpfung  D'), ylabel ('Wert der Integralkriterien  A')

%Zeitgewichtete Betragsregelflche ITAE
i = 1;
for D = DD
    x = step(tf (1.0, [1 2.0*D 1]), t);
    A(i) = delta_t * trapz(t' .* abs(1.0 - x));
    i = i + 1;
end
plot(DD, A) 

%Zeitquadratgewichtete Betragsregelflche ISTAE
i = 1;
for D = DD
    x = step(tf (1.0, [1 2.0*D 1]), t);
    A(i) = delta_t * trapz((t'.*t') .* abs(1.0 - x));
    i = i + 1;
end
plot(DD, A) 

%Quadratische Regelflche ISE
i = 1;
for D = DD
    x = step(tf (1.0, [1 2.0*D 1]), t);
    A(i) = delta_t * trapz((abs(1.0 - x)).^2);
    i = i + 1;
end
plot(DD, A) 

%Zeitgewichtete Quadratische Regelflche ITSE
i = 1;
for D = DD
    x = step(tf (1.0, [1 2.0*D 1]), t);
    A(i) = delta_t * trapz(t' .* (abs(1.0 - x)).^2);
    i = i + 1;
end
plot(DD, A) 

%Zeitquadratgewichtete Quadratische Regelflche ISTSE
i = 1;
for D = DD
    x = step(tf (1.0, [1 2.0*D 1]), t);
    A(i) = delta_t * trapz((t').^2 .* (abs(1.0 - x)).^2);
    i = i + 1;
end
plot(DD, A) 

%Zeitlinear gewichtete Regelflche IE
plot([0 1],[0 2])

text(0.12, 0.4,'IE')
text(0.525, 1.8,'IAE')
text(0.61, 2.4,'ITAE')
text(0.65, 4.5,'ISTAE')
text(0.1225, 1.5,'ISE')
text(0.5, 0.55,'ITSE')
text(1.245, 3.25,'ISTSE')

%{
%Betragsregelflche IAE
D_opt_IAE =   0.662400000000000
A_min =   1.605148556065305
ue =   0.062175047365894

%Zeitgewichtete Betragsregelflche ITAE
D_opt_ITAE =   0.752400000000000
A_min =   1.951859483565610
ue =   0.027641182613718

%Zeitquadratgewichtete Betragsregelflche ISTAE
D_opt_ISTAE =   0.813800000000000
A_min =   4.331462533959664
ue =   0.012286006442300

%Quadratische Regelflche ISE
D_opt_ISE =   0.500000000000000
A_min =   1.000004999997881
ue =   0.163033534821449

%Zeitgewichtete Quadratische Regelflche ITSE
D_opt_ITSE =   0.594600000000000
A_min =   0.707106781224409
ue =   0.097948909164117

%Zeitquadratgewichtete Quadratische Regelflche ISTSE
D_opt_ISTSE =   0.667300000000000
A_min =   0.868630067579477
ue =   0.059920514578427
%}


