   %MATLAB Script-File: D_ZULAI1.m
   %Digitale Integral-Zustands-Lageregelung

   %Fhrungssprungantwort
   clf
   TM=0.02; TES=0.0015; 		%Streckenparameter
   KS1=0.3; KS2=1;
   AI=[0, 1, 0, 0,				%Systemmatrix
   0, -1/TM, KS2/TM, 0,			%erweiterte Strecke
   0, 0, -1/TES, 0,
	-1, 0, 0, 0];
   BI=[0, 0, 0; 					%Eingangsmatrix Strecke:
   0, -KS2/TM, 0; 				%MMs, ML, Phis
   KS1/TES, 0, 0; 
   0, 0, 1];	
   cIT=[1, 0, 0, 0];				%Ausgangsvektor
   dI=[0, 0, 0];					%Durchgangsvektor
   a_Strecke=ss(AI,BI,cIT,dI);%Zustandsmodell der Strecke
   T=[0.0001 0.001, 0.003];	%Abtastzeit

   for i=1:3
   l=0:T(i):0.05;					%Anzahl Elemente des Zeitvektors
   d_Strecke=c2d(a_Strecke,T(i));%Zeitdiskretes Zustandsmodell S.
   [d_AI,d_BI,d_cI,d_dI,T(i)]=ssdata(d_Strecke);

   spZ=-396.3;						%Vorgabepole s-Ebene
   d_spZ=exp(spZ*T(i));			%Vorgabepole z-Ebene
   d_poleZ=[d_spZ,d_spZ,d_spZ,d_spZ];
   d_rR=acker(d_AI,d_BI(:,1),d_poleZ);%Polvorgabe zeitdiskret
   d_rR=-d_rR;						%Rckfhrvektor zeitdiskret
   d_AR=d_AI+d_BI(:,1)*d_rR;	%Systemmatrix der Zeitdiskr. R.
   d_ZU=ss(d_AR,d_BI(:,3),d_cI,d_dI(1),T(i));
   [y1,dT]=step(d_ZU,l);
   subplot(211), 
	switch i
   case 1
      plot(dT,y1,'-')
   otherwise
      plot(dT,y1,'o',dT,y1,'-')
   end
   title('Fhrungssprungantwort')
   xlabel('t/s')
   ylabel('(t)')
   hold on, grid on

   %Strsprungantwort
   d_ZUS=ss(d_AR,d_BI(:,2),d_cI,d_dI(2),T(i));
   [y2,dT]=step(d_ZUS,l);
   subplot(212),
	switch i
   case 1
      plot(dT,y2,'-')
   otherwise
      plot(dT,y2,'o',dT,y2,'-')
   end
   title('Strungssprungantwort')
   xlabel('t/s')
   ylabel('(t)')
   hold on, grid on
   end
