%MATLAB Script-File sprung_165.m
%Einheits-Sprungantwortfunktion fr PT1- und PT2-Element
hold on                    %Kurve nicht berschreiben
grid on                    %kartesische Gitterlinien
w0=0.5; D=0.25; KP1=1; T1=4; %Parameter

numG1=KP1; denG1=[T1 1];   %Zhler- u. Nennerpolynom PT1-Element
G1=tf(numG1,denG1);        %bertragungsfunktion G1(s)
numG2=w0^2;                %Zhler- u. Nennerpolynom
denG2=[1 2*D*w0 w0^2];     %des PT2-Elements
G2=tf(numG2,denG2);		   %bertragungsfunktion G2(s)

t=0:0.4:20;                %Vektor der Zeitwerte
xa1=step(G1,t);   		   %PT1-Sprungantwort
xa2=step(G2,t);   		   %PT2-Sprungantwort

KP_PT1=dcgain(G1) 	   	   %Proportionalbeiwert des PT1-Elements
KP_PT2=dcgain(G2) 		   %Proportionalbeiwert des PT2-Elements

plot(t,xa1,'-')            %PT1-Sprungantwort plotten
plot(t,xa2,'-.')           %PT2-Sprungantwort plotten

title('\it{Einheits-Sprungantwort}')
xlabel('\it{Zeit t/s}')    %Beschriftung der Abszisse
ylabel('{\itx}_a{\it(t)}') %Beschriftung der Ordinate
legend('{\itPT}_1{\it-Element}','{\itPT}_2{\it-Element}') %Legende